﻿--ver: 1.0a
---AddFriend is reserved by WoW, so to prevent conflicts using AFriend
--Call console for commands, event for click events, Hook for any needed hooks into the dropdowns.
AFriend = LibStub("AceAddon-3.0"):NewAddon("AFriend", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0");

local AFriend = AFriend;

function AFriend:OnInitialize()
	local versionString = GetAddOnMetadata("AddFriend", "Version")
end

function AFriend:OnEnable()
	self:SecureHook("UnitPopup_ShowMenu");
	--self:RawHook("ChatFrame_OnEvent", true);
end

function AFriend:OnDisable()
	self:Unhook("UnitPopup_ShowMenu");
	--self:Unhook("ChatFrame_OnEvent");
end

function AFriend:UnitPopup_ShowMenu(dropdownMenu, which, unit, name, userData)
	--if the context request was a friend or something we can't add then return we don't need to add them
	--TODO: return if unit is a hostile character player we cant add.
	--TODO: Check if isFriend, then switch to remove friend
	if(which == "PET" or which == "SELF") then
		return;
	--Otherwise check to make sure we can do something with the request
	elseif(which ~= "FRIEND" and which ~= "PLAYER" and which ~= "PARTY" and which ~= "RAID_PLAYER" and which ~= "RAID") then
		return;
	end

	if (UIDROPDOWNMENU_MENU_LEVEL > 1) then
		return;
	end

	local info = UIDropDownMenu_CreateInfo();
		info.text = "Add to Friends";
		info.value = "Add to Friends";
		info.owner = which;
		info.func = AFriend_ContextMenu_OnClick;
		info.notCheckable = true;
		info.arg1 = {["unit"] = unit, ["name"] = name};
	UIDropDownMenu_AddButton(info);
	
end

--TODO: add send them a tell with addon options
function AFriend_ContextMenu_OnClick(self, info)
		assert(info);
		name = info.name or UnitName(info.unit);
		assert(name);
		AddFriend(name);
end

function AFriend:ChatFrame_OnEvent(frame, event, ...)
	return self.hooks["ChatFrame_OnEvent"](frame, event, ...);
end